Bug 611907 - Browse mode performance in a queue degrades as queue gets larger
Browse mode performance in a queue degrades as queue gets larger
Status: CLOSED ERRATA
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: qpid-cpp (Show other bugs)
1.2
All Linux
high Severity medium
: 1.2.2
: ---
Assigned To: Gordon Sim
MRG Quality Engineering
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-07-06 16:16 EDT by Mike Cressman
Modified: 2010-10-07 21:50 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
C: reading messages from a queue sequentially without taking them off the queue (browse mode) C: performance scales poorly as the size of the queue grows F: change the algorithm for traversing through the messages R: the next message is found more quickly, even for large queues
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-10-07 21:50:06 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Mike Cressman 2010-07-06 16:16:39 EDT
Description of problem:
Browsing messages in a queue slows down exponentially as the number of messages in the queue increases, while maxing out the CPU available.


Version-Release number of selected component (if applicable):
MRG Messaging 1.2

How reproducible:
Every time

Steps to Reproduce:
1. Create a queue
2. Add a number of messages to the queue (say, 25,000)
3. Read them off the queue in browse mode (ACQUIRE_MODE_NOT_ACQUIRED), i.e. read the messages off the queue but do not acknowledge them (leave them on the queue).  Note the time that it takes.
4. Double the number of messages on the queue (to 50,000)
5. Again, read them in browse mode.
  
Actual results:
It takes about 4 times as long to read twice as many messages.  This ratio continues if the queue is made even larger.

Expected results:
Performance degradation should be closer to linear.

Additional info:
Comment 2 Mike Cressman 2010-09-24 11:15:00 EDT
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
C: reading messages from a queue sequentially without taking them off the queue (browse mode)
C: performance scales poorly as the size of the queue grows
F: change the algorithm for traversing through the messages
R: the next message is found more quickly, even for large queues
Comment 6 errata-xmlrpc 2010-10-07 21:50:06 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2010-0756.html

Note You need to log in before you can comment on or make changes to this bug.